--- Smac/For_.h	2006-10-16 16:22:30.000000000 -0400
+++ Smac/For_.h	2014-12-27 22:05:24.000000000 -0500
@@ -59,5 +59,5 @@ extern FCT( For *, For__For,(Instruction
 			     Instruction *, Instruction *, int));
 
-extern void Init_For();
+extern void Init_For(void);
 
 #endif
--- Smac/FunctionCall_.h	2006-10-16 16:22:03.000000000 -0400
+++ Smac/FunctionCall_.h	2014-12-27 17:10:21.000000000 -0500
@@ -109,5 +109,5 @@ extern FCT( void, call_builtin_function_
 #endif
      
-void Init_FunctionCall();
+void Init_FunctionCall(void);
 
 #endif
--- Smac/Function_.c	2006-10-16 16:24:11.000000000 -0400
+++ Smac/Function_.c	2014-12-27 22:01:11.000000000 -0500
@@ -57,6 +57,6 @@ Function * Function__Function(nom, valty
      int mayfree;
 {
-  Function * this = (Function *) Malloc(sizeof(Function));
-  TypeFunction * typefunction = (TypeFunction *) Malloc(sizeof(TypeFunction));
+  Function * this = Malloc(sizeof(Function));
+  TypeFunction * typefunction = Malloc(sizeof(TypeFunction));
   Type * thetype;
   
@@ -102,5 +102,5 @@ Function * Function__Function(nom, valty
 
 static void Function__Delete(this)
-     Function * this;
+     Function * this __attribute__((unused));
 {
   // does nothing !
@@ -229,5 +229,5 @@ static void UndefinedFunctionCall__Delet
 
 int Function__IsUndefined(f)
-     Function * f;
+     const Function * f;
 {
  return (f->_def._user_def->instruction_functions ==
@@ -245,5 +245,5 @@ void Init_UndefinedFunctionCall()
 
 int IsaFunction(i)
-     Instruction * i;
+     const Instruction * i;
 {
   return ((i->instruction_functions ==
@@ -257,7 +257,7 @@ int IsaFunction(i)
 
 int IsaPointerToFunction(f)
-     void * f;
+     const void * f;
 {
-  return((f != 0) &&
+  return((f != NULL) &&
 #ifdef RUNTIMECHECK
 	 (((char *) f < Address_Min) ||
@@ -267,5 +267,5 @@ int IsaPointerToFunction(f)
 	 (! ((Object) f & CHECK_POINTER_POINTER)) 	&&
 #endif
-	 IsaFunction((Instruction *) f)
+	 IsaFunction(f)
 	 );
 }
--- Smac/Function_.h	2006-10-16 16:23:32.000000000 -0400
+++ Smac/Function_.h	2014-12-27 22:00:54.000000000 -0500
@@ -84,5 +84,5 @@ extern FCT(void, Function__UpdateDef,(Fu
 extern FCT(int, Function__VerifyNotActive,(Function * this, int nojmp));
 
-void Init_Function();
+void Init_Function(void);
 
 /**/
@@ -99,9 +99,9 @@ extern FCT( UndefinedFunctionCall *,
 	   (Function * func));
 
-extern FCT ( int, IsaFunction,(Instruction *)		);
-extern FCT ( int, Function__IsUndefined,(Function *)	);
-extern FCT ( int, IsaPointerToFunction,(void *)		);
+extern FCT ( int, IsaFunction, (const Instruction *)		);
+extern FCT ( int, Function__IsUndefined, (const Function *)	);
+extern FCT ( int, IsaPointerToFunction, (const void *)		);
      
-void Init_UndefinedFunctionCall();
+void Init_UndefinedFunctionCall(void);
   
 #endif
--- Smac/Identifier_.h	2006-10-16 16:23:01.000000000 -0400
+++ Smac/Identifier_.h	2014-12-27 21:48:02.000000000 -0500
@@ -60,5 +60,5 @@ typedef struct Identifier Identifier;
 
 extern FCT( Identifier *, Identifier__Identifier,
-	   	(char *, Function *, GlobalVar *));
+   	(char *, Function *, GlobalVar *));
 
 extern FCT ( Identifier *, Get_Identifier,(char * name)	);
@@ -69,5 +69,5 @@ extern FCT ( Identifier *, Get_Identifie
 extern HashTable * IdentifierHashTable;
 
-extern void Init_Identifier();
+extern void Init_Identifier(void);
 
-#endif
+#endif
\ No newline at end of file
--- Smac/If_.h	2006-10-16 16:22:26.000000000 -0400
+++ Smac/If_.h	2014-12-27 17:06:30.000000000 -0500
@@ -71,5 +71,5 @@ extern FCT( ArithIf *, ArithIf__ArithIf,
 
 
-extern void Init_If();
+extern void Init_If(void);
 
-#endif
+#endif
\ No newline at end of file
--- Smac/RefDeref_.c	2006-10-16 16:39:09.000000000 -0400
+++ Smac/RefDeref_.c	2014-12-27 22:31:05.000000000 -0500
@@ -59,6 +59,6 @@
 /* Les fonctions d'indirection en fonction de leur type */
 
-Object char_indirection(p)
-     char * p;
+static Object char_indirection(p)
+     const char * p;
 {
 #ifdef RUNTIMECHECK
@@ -70,9 +70,9 @@ Object char_indirection(p)
 }
 
-Object int_indirection(p)
-     int * p;
+static Object int_indirection(p)
+     const int * p;
 {
 #ifdef RUNTIMECHECK
-  if (((char *) p < Address_Min) || ((char *) p > Address_Int_Max))
+  if (((const char *) p < Address_Min) || ((const char *) p > Address_Int_Max))
     Error("int access through pointer out of your memory area", 0);
 
@@ -86,9 +86,9 @@ Object int_indirection(p)
 }
 
-Object pointer_indirection(p)
-     Object * p;
+static Object pointer_indirection(p)
+     const Object * p;
 {
 #ifdef RUNTIMECHECK
-  if (((char *) p < Address_Min) || ((char *) p > Address_Pointer_Max))
+  if (((const char *) p < Address_Min) || ((const char *) p > Address_Pointer_Max))
     Error("pointer access through pointer out of your memory area", 0);
 
@@ -102,6 +102,6 @@ Object pointer_indirection(p)
 }
 
-Object sub_array_indirection(p)
-     char * p;
+static Object sub_array_indirection(p)
+     const char * p;
 {
   return (Object) (p);
@@ -155,5 +155,5 @@ static Object Indirection__Eval(this)
 /* Les fonctions d'affectation en fonction de leur type */
 
-Object char_indirection_assignment(p, value)
+static Object char_indirection_assignment(p, value)
      char * p;
      Object value;
@@ -162,5 +162,5 @@ Object char_indirection_assignment(p, va
 }
 
-Object int_indirection_assignment(p, value)
+static Object int_indirection_assignment(p, value)
      int * p;
      Object value;
@@ -169,5 +169,5 @@ Object int_indirection_assignment(p, val
 }
 
-Object pointer_indirection_assignment(p, value)
+static Object pointer_indirection_assignment(p, value)
      Object * p;
      Object value;
@@ -181,5 +181,5 @@ Object pointer_indirection_assignment(p,
    car le test d'adresse est realise lors de l'acces */
 
-Object check_char_indirection_assignment(p, value)
+static Object check_char_indirection_assignment(p, value)
      char * p;
      Object value;
@@ -206,5 +206,5 @@ Object check_int_indirection_assignment(
 }
 
-Object check_pointer_indirection_assignment(p, value)
+static Object check_pointer_indirection_assignment(p, value)
      Object * p;
      Object value;
--- Smac/RefDeref_.h	2006-10-16 16:22:53.000000000 -0400
+++ Smac/RefDeref_.h	2014-12-27 22:31:52.000000000 -0500
@@ -105,5 +105,7 @@ extern FCT(IndirectionPostIncrDecr  *,
 	    Type *, FCT2(Object,(*),(Object) )));
 
-extern void Init_RefDeref();
+extern void Init_RefDeref(void);
 
-#endif
+extern FCT(Object, check_int_indirection_assignment, (int *p, Object value));
+
+#endif
\ No newline at end of file
--- Smac/Return_.h	2006-10-16 16:22:22.000000000 -0400
+++ Smac/Return_.h	2014-12-27 17:06:47.000000000 -0500
@@ -55,5 +55,5 @@ typedef struct Return Return;
 extern FCT( Return *,Return__Return,(Instruction * value, int term)	);
 
-extern void Init_Return();
+extern void Init_Return(void);
 
 #endif
--- Smac/Switch_.h	2006-10-16 16:23:19.000000000 -0400
+++ Smac/Switch_.h	2014-12-27 22:13:23.000000000 -0500
@@ -61,5 +61,5 @@ extern FCT( Switch *,Switch__Switch,(Ins
 				     int *, int, int, int)		);
 
-extern void Init_Switch();
+extern void Init_Switch(void);
 
 #endif
--- Smac/Type_.c	2006-10-16 16:24:01.000000000 -0400
+++ Smac/Type_.c	2014-12-27 16:57:36.000000000 -0500
@@ -145,6 +145,6 @@ void Type__Delete(this)
 
 int Type__Equal(t1, t2)
-     Type * t1;
-     Type * t2;
+     const Type * t1;
+     const Type * t2;
 {
   int firstdim = 1;
@@ -190,6 +190,6 @@ int Type__Equal(t1, t2)
 
 int Type__Eq(t1, t2)
-     Type * t1;
-     Type * t2;
+     const Type * t1;
+     const Type * t2;
 {
   for (;;) {
@@ -222,6 +222,6 @@ int Type__Eq(t1, t2)
     }
     
-    t1 = (Type *) t1->_name_or_pointed;
-    t2 = (Type *) t2->_name_or_pointed;
+    t1 = t1->_name_or_pointed;
+    t2 = t2->_name_or_pointed;
   }
 }
@@ -231,5 +231,5 @@ int Type__Eq(t1, t2)
 
 void Type__Print(t, str)
-    Type * t;
+    const Type * t;
     char * str;
 {
@@ -269,6 +269,6 @@ HashTable * convert_hash_table;
 
 ConvFct Type__Convertible(t1, t2)
-     Type * t1;
-     Type * t2;
+     const Type * t1;
+     const Type * t2;
 {
   if (Type__Equal(t1, t2))
@@ -278,6 +278,6 @@ ConvFct Type__Convertible(t1, t2)
     /* type * convertible en void * */
     
-    Type * st1 = t1;
-    Type * st2 = t2;
+    const Type * st1 = t1;
+    const Type * st2 = t2;
 
     while (((st1->_type ==  T_Array) || (st1->_type == T_Pointer)) &&
@@ -297,9 +297,8 @@ ConvFct Type__Convertible(t1, t2)
   {
     /* Regarde s'il y a une conversion possible */
-    
-    char encoded[24];
-    
-    sprintf(encoded, "%s2", encode_type(t1));
-    strcat(encoded, encode_type(t2));
+ 
+    char encoded[48];
+ 
+    snprintf(encoded, sizeof(encoded), "%s2%s", encode_type(t1), encode_type(t2));
 
     return (ConvFct) HashTable__Search(convert_hash_table, (Object) encoded);
@@ -313,5 +312,5 @@ ConvFct Type__Convertible(t1, t2)
 ConvFct ExprType__Convertible(i, t)
      Instruction * i;
-     Type * t;
+     const Type * t;
 {
   Type * ti = GetExprType(i);
@@ -344,7 +343,7 @@ int char2int(c)
 
 void error_incompatible_types(t1, t2, msg)
-    Type * t1;
-    Type * t2;
-    char * msg;
+    const Type * t1;
+    const Type * t2;
+    const char * msg;
 {
   strcpy(err_msg, msg);
--- Smac/Type_.h	2006-10-16 16:22:49.000000000 -0400
+++ Smac/Type_.h	2014-12-27 16:57:16.000000000 -0500
@@ -71,9 +71,9 @@ extern FCT( Type *, Type__Type,(void * s
 
 extern FCT( void, Type__Delete,(Type *)			);
-extern FCT( int, Type__Equal,(Type *, Type *)		);
-extern FCT( int, Type__Eq,(Type *, Type *)		);
-extern FCT( void, Type__Print,(Type *, char *)		);
-extern FCT( ConvFct, Type__Convertible,(Type *, Type *)	);
-extern FCT( ConvFct, ExprType__Convertible,(Instruction *, Type *)	);
+extern FCT( int, Type__Equal, (const Type *, const Type *));
+extern FCT( int, Type__Eq, (const Type *, const Type *)	);
+extern FCT( void, Type__Print, (const Type *, char *)	);
+extern FCT( ConvFct, Type__Convertible, (const Type *, const Type *));
+extern FCT( ConvFct, ExprType__Convertible, (Instruction *, const Type *));
 
 #define AlreadyConvertible	((ConvFct) Type__Convertible)
@@ -111,5 +111,5 @@ extern Type * Type_PInt;
 extern Type * Type_PVoid;
 
-extern FCT( void, error_incompatible_types,(Type * t1, Type * t2, char * msg)	);
+extern FCT( void, error_incompatible_types, (const Type * t1, const Type * t2, char const * msg)	);
 
 /**/
@@ -127,5 +127,5 @@ extern FCT( Instruction *, Conv__Conv,(I
 /**/
 
-void Init_type();
+void Init_type(void);
      
 #endif
--- Smac/Var_.c	2006-10-16 16:25:03.000000000 -0400
+++ Smac/Var_.c	2014-12-27 21:47:07.000000000 -0500
@@ -60,5 +60,5 @@ LocalVar * LocalVar__LocalVar(nom, posit
      Type * t;
 {
-  LocalVar * this = (LocalVar *) Malloc(sizeof(LocalVar));
+  LocalVar * this = Malloc(sizeof(LocalVar));
   
   Instruction_Constructor
@@ -72,5 +72,5 @@ LocalVar * LocalVar__LocalVar(nom, posit
 
 static void LocalVar__Delete(this)
-     LocalVar * this;
+     LocalVar * this __attribute__((unused));
 {
   /* does nothing */
@@ -85,5 +85,5 @@ void LocalVar__free(this)
 }
 
-Object LocalVar__Eval(this)
+static Object LocalVar__Eval(this)
      LocalVar * this;
 {
@@ -130,5 +130,5 @@ static void LocalVarAssignment__Delete(t
 }
 
-Object LocalVarAssignment__Eval(this)
+static Object LocalVarAssignment__Eval(this)
      LocalVarAssignment * this;
 {
@@ -176,5 +176,5 @@ static void LocalVarPostIncrDecr__Delete
 }
 
-Object LocalVarPostIncrDecr__Eval(this)
+static Object LocalVarPostIncrDecr__Eval(this)
      LocalVarPostIncrDecr * this;
 {
@@ -196,5 +196,5 @@ Object LocalVarPostIncrDecr__Eval(this)
 /* Reference a une variable locale (&) */
 
-int correction_adresses(type)
+static int correction_adresses(type)
      Type * type;
 {
@@ -238,5 +238,5 @@ LocalVarRef * LocalVarRef__LocalVarRef(v
 }
 
-Object LocalVarRef__Eval(this)
+static Object LocalVarRef__Eval(this)
      LocalVarRef * this;
 {
@@ -245,5 +245,5 @@ Object LocalVarRef__Eval(this)
 
 int IsaLocalVar(i)
-     Instruction * i;
+     const Instruction * i;
 {
   return (i->instruction_functions ==
@@ -282,9 +282,9 @@ inherit_instruction_function_vector
 
 GlobalVar * GlobalVar__GlobalVar(nom, type, value)
-     char * nom;
+     const char * nom;
      Type * type;
      Object value;
 {
-  GlobalVar * this = (GlobalVar *) Malloc(sizeof(GlobalVar));
+  GlobalVar * this = Malloc(sizeof(GlobalVar));
   
   Instruction_Constructor
@@ -294,5 +294,5 @@ GlobalVar * GlobalVar__GlobalVar(nom, ty
 #ifdef RUNTIMECHECK
   {
-    Object * pvalue = (Object *) RTCMalloc(sizeof(Object));
+    Object * pvalue = RTCMalloc(sizeof(Object));
 
     forbit_RTCfree(pvalue);
@@ -308,5 +308,5 @@ GlobalVar * GlobalVar__GlobalVar(nom, ty
 
 static void GlobalVar__Delete(this)
-     GlobalVar * this;
+     GlobalVar * this __attribute__((unused));
 {
   /* does nothing ! */
@@ -324,5 +324,5 @@ void GlobalVar__Update(this, value)
 }
 
-Object GlobalVar__Eval(this)
+static Object GlobalVar__Eval(this)
      GlobalVar * this;
 {
@@ -335,5 +335,5 @@ Object GlobalVar__Eval(this)
 
 int IsaGlobalVar(i)
-     Instruction * i;
+     const Instruction * i;
 {
   return (i->instruction_functions ==
@@ -385,6 +385,6 @@ static void GlobalVarAssignment__Delete(
 }
 
-Object GlobalVarAssignment__Eval(this)
-     GlobalVarAssignment * this;
+static Object GlobalVarAssignment__Eval(this)
+     const GlobalVarAssignment * this;
 {
   return *(this->_pvalue) = Eval(this->_value);
@@ -416,5 +416,5 @@ GlobalVarRef * GlobalVarRef__GlobalVarRe
 }
 
-Object GlobalVarRef__Eval(this)
+static Object GlobalVarRef__Eval(this)
      GlobalVarRef * this;
 {
@@ -466,6 +466,6 @@ static void GlobalVarPostIncrDecr__Delet
 }
 
-Object GlobalVarPostIncrDecr__Eval(this)
-     GlobalVarPostIncrDecr * this;
+static Object GlobalVarPostIncrDecr__Eval(this)
+     const GlobalVarPostIncrDecr * this;
 {
   Object value;
--- Smac/Var_.h	2006-10-16 16:22:18.000000000 -0400
+++ Smac/Var_.h	2014-12-27 21:46:51.000000000 -0500
@@ -93,8 +93,8 @@ typedef struct LocalVarRef LocalVarRef;
 extern FCT (LocalVarRef *, LocalVarRef__LocalVarRef, (LocalVar * var));
 
-extern FCT (int, IsaLocalVar,(Instruction *)				);
+extern FCT (int, IsaLocalVar, (const Instruction *)			);
 
 
-void Init_LocalVar();
+void Init_LocalVar(void);
 
 	    
@@ -104,10 +104,10 @@ struct GlobalVar {
   Inherit_Instruction;
 
-  char * _name;
+  const char * _name;
   Object _value;
 };
 typedef struct GlobalVar GlobalVar;
 
-extern FCT (GlobalVar *, GlobalVar__GlobalVar, (char *, Type *, Object)	);
+extern FCT (GlobalVar *, GlobalVar__GlobalVar, (const char *, Type *, Object)	);
 extern FCT (void, GlobalVar__Update, (GlobalVar *, Object)	);
 
@@ -134,5 +134,5 @@ extern FCT (GlobalVarRef *, GlobalVarRef
 struct GlobalVarPostIncrDecr {
   Inherit_Instruction;
-  
+
   Object * _pvalue;
   Instruction * _value;
@@ -145,7 +145,7 @@ extern FCT (GlobalVarPostIncrDecr *,
 	    (GlobalVar *, Instruction *, Type *)	);
 
-extern FCT (int, IsaGlobalVar,(Instruction *)				);
+extern FCT (int, IsaGlobalVar, (const Instruction *)	);
 
-void Init_GlobalVar();
+void Init_GlobalVar(void);
 
 #ifdef RUNTIMECHECK
@@ -155,3 +155,3 @@ void Init_GlobalVar();
 #endif
     
-#endif
+#endif
\ No newline at end of file
--- Smac/While_.h	2006-10-16 16:20:57.000000000 -0400
+++ Smac/While_.h	2014-12-27 22:04:54.000000000 -0500
@@ -58,5 +58,5 @@ extern FCT( While *, While__While,(Instr
 extern FCT( While *, DoWhile__DoWhile, (Instruction *, Instruction *, int));
 
-extern void Init_While();
+extern void Init_While(void);
 
 #endif
--- Smac/assignment.c	2006-10-16 16:31:37.000000000 -0400
+++ Smac/assignment.c	2014-12-27 16:41:13.000000000 -0500
@@ -68,5 +68,5 @@
 /* Modification d'une (supposee) variable */
 
-Instruction * var_assignment(mkident, lvalue, opername, cast, del)
+static Instruction * var_assignment(mkident, lvalue, opername, cast, del)
      List * mkident;
      List * lvalue;
@@ -203,7 +203,7 @@ Instruction * make_assignment(l, del)
 /* Modification d'une (supposee) variable */
 
-Instruction * var_post_incrdecr(mkident, ivalue, cast, del)
+static Instruction * var_post_incrdecr(mkident, ivalue, cast, del)
      List * mkident;
-     int    ivalue;
+     intptr_t  ivalue;
      Type * cast;
      int del;
@@ -235,12 +235,12 @@ Instruction * var_post_incrdecr(mkident,
   /* fabrique l'affectation */
 
-  m = (List **) Malloc(3 * sizeof(List *));
+  m = Malloc(3 * sizeof(List *));
   ((char **) m)[0] = Strdup("+");
   if (cast) {
-    void ** cm = (void **) Malloc(2 * sizeof(void *));
+    void ** cm = Malloc(2 * sizeof(void *));
 
-    cm[0] = (void *) cast;
-    cm[1] = (void *) mkident;
-    m[1] = List__List(make_cast, (void *) cm);
+    cm[0] = cast;
+    cm[1] = mkident;
+    m[1] = List__List(make_cast, cm);
   }
   else
--- Smac/c5.y	2002-07-19 09:00:18.000000000 -0400
+++ Smac/c5.y	2014-12-27 15:14:02.000000000 -0500
@@ -87,5 +87,6 @@ colleagues include: Bruce Blodgett, and 
 
 #include "rename.h"
-  
+#include "mylex.h"
+
 %}
 
@@ -770,9 +771,9 @@ postfix_abstract_declarator:
 
 int numlig;
-char * yyinfilename = 0;
+const char * yyinfilename = 0;
 extern char err_msg[];
 
 void yyerror(string)
-     char *string;
+     const char *string;
 {
   /* Attention, la forme du message est connue dans smacXcoral,c */
@@ -786,4 +787,3 @@ void yyerror(string)
       sprintf(err_msg, "parser error line %d : %s", numlig, string);
   }
-}
-
+}
\ No newline at end of file
--- Smac/comma.c	2006-10-16 16:32:03.000000000 -0400
+++ Smac/comma.c	2014-12-27 16:35:35.000000000 -0500
@@ -44,4 +44,5 @@
 #include "error.h"
 
+#include "comma.h"
 #include "decl.h" /**/
 
@@ -58,6 +59,6 @@ Instruction * no_comma_expression(l, del
 
   return (del)
-    ? (Instruction *) 0
-    : (Instruction *) CommaExpression__CommaExpression(0, 0, 0);
+    ? NULL
+    : (Instruction *)CommaExpression__CommaExpression(NULL, NULL, 0);
 }
 
--- Smac/const.c	2006-10-16 16:31:30.000000000 -0400
+++ Smac/const.c	2014-12-27 15:30:32.000000000 -0500
@@ -69,5 +69,5 @@ Instruction * make_integer(l, del)
 
 char lire_char(s)
-     char * s;
+     const char * s;
 {
   if (*++s == '\\')
@@ -130,13 +130,13 @@ Instruction * make_char(l, del)
 
 char * lire_string(str)
-     char * str;
+     const char * str;
 {
 #ifdef RUNTIMECHECK
-  char * decoded = (char *) RTCMalloc(strlen(str) - 1);
+  char * decoded = RTCMalloc(strlen(str) - 1);
   char * pdecoded = decoded;
 
   forbit_RTCfree(decoded);
 #else
-  char * decoded = (char *) Malloc(strlen(str) - 1);
+  char * decoded = Malloc(strlen(str) - 1);
   char * pdecoded = decoded;
 #endif
--- Smac/const.h	2006-10-16 16:30:13.000000000 -0400
+++ Smac/const.h	2014-12-27 14:21:00.000000000 -0500
@@ -49,7 +49,7 @@
 extern FCT( Instruction *, make_integer,(List *, int)	);
 extern FCT( Instruction *, make_char,(List *, int)	);
-extern FCT( char, lire_char,(char *)			);
+extern FCT( char, lire_char,(const char *)		);
 extern FCT( Instruction *, make_string,(List *, int)	);
-extern FCT( char *, lire_string,(char *)		);
+extern FCT( char *, lire_string,(const char *)		);
 
 #endif
--- Smac/control.h	2006-10-16 16:29:49.000000000 -0400
+++ Smac/control.h	2014-12-27 15:37:04.000000000 -0500
@@ -59,5 +59,5 @@ extern int in_switch;
 extern FCT(Instruction *, make_control,(List *, int)	);
      
-extern void Reinit_Control();
+extern void Reinit_Control(void);
 
 #endif
--- Smac/decl.h	2006-10-16 16:30:37.000000000 -0400
+++ Smac/decl.h	2014-12-27 16:28:31.000000000 -0500
@@ -41,7 +41,9 @@
 
 #include <string.h>
+#include <stdint.h>
 
 /* Pour aider la construction des instructions */
 
+#include "const.h"
 #include "list.h"
 #include "Instruction_.h"
@@ -50,18 +52,13 @@ extern int Is_Terminal;
 extern int Has_Unterminal_Return;
 
-extern FCT( Instruction *, make_integer,(List *, int) );
 #define memo_integer(str)		\
-	AddLast(Memo, List__List(make_integer, (void *) atoi(str)))
+	AddLast(Memo, List__List(make_integer, (void *)(intptr_t)atoi(str)))
 
 #define memo_negate_integer(str)		\
-	AddLast(Memo, List__List(make_integer, (void *) -atoi(str)))
+	AddLast(Memo, List__List(make_integer, (void *)(intptr_t)-atoi(str)))
 
-extern FCT( Instruction *, make_char,(List *, int) );
-extern FCT( char, lire_char,(char *) );
 #define memo_char(str)		\
-	AddLast(Memo, List__List(make_char, (void *) (int) lire_char(str)))
+	AddLast(Memo, List__List(make_char, (void *)(intptr_t)lire_char(str)))
 
-extern FCT( Instruction *, make_string,(List *, int) );
-extern FCT( char *, lire_string,(char *)	);
 #define memo_string(str)		\
 	AddLast(Memo, List__List(make_string, lire_string(str)))
@@ -70,6 +67,6 @@ extern FCT( char *, lire_string,(char *)
 
 extern FCT( Instruction *, just_a_mark,(List *, int) );
-extern FCT( void, memo_empty_block,() );
-extern FCT( void, memo_block,() );
+extern FCT( void, memo_empty_block, (void) );
+extern FCT( void, memo_block, (void) );
 extern char * begin_block;
 
@@ -195,5 +192,5 @@ extern FCT( Instruction *, make_case,(Li
 	AddLast(Memo, List__List(make_case, 0))
 
-extern FCT( void, memo_switch,() );
+extern FCT( void, memo_switch, (void) );
 
 extern FCT( Instruction *, make_if,(List *, int) );
@@ -237,5 +234,5 @@ extern FCT( Instruction *, make_for,(Lis
 /**/
 
-extern FCT( void, memo_comma,() );
+extern FCT( void, memo_comma, (void) );
      
 extern FCT( Instruction *, no_comma_expression,(List *, int) );
@@ -266,5 +263,5 @@ extern FCT( Instruction *, make_funcall,
 	AddLast(Memo, List__List(make_funcall, (char*) m))
 
-extern FCT( void, memo_funcall_nargs,() );
+extern FCT( void, memo_funcall_nargs, (void) );
 
 /**/
@@ -320,5 +317,5 @@ extern char * begin_initializer_list;
   	AddLast(Memo, List__List(just_a_mark, begin_initializer_list))
 
-extern FCT ( void, memo_initializer_list,()	);
+extern FCT ( void, memo_initializer_list, (void)	);
 
 /**/
@@ -328,7 +325,7 @@ extern char * begin_of_list;
   	AddLast(Memo, List__List(just_a_mark, begin_of_list))
 
-extern FCT( void, end_of_list, () );
-extern FCT( void, forget_list, () );
-extern FCT( void, forget_list_if_possible, () );
+extern FCT( void, end_of_list, (void) );
+extern FCT( void, forget_list, (void) );
+extern FCT( void, forget_list_if_possible, (void) );
 
 
@@ -339,6 +336,6 @@ extern char * begin_function_parameter_t
   	AddLast(Memo, List__List(just_a_mark, begin_function_parameter_type_list))
 
-extern FCT( void, end_function_parameter_type_list,() );
-extern FCT( void, end_identifier_list,() );
+extern FCT( void, end_function_parameter_type_list,(void) );
+extern FCT( void, end_identifier_list,(void) );
 
 extern char * begin_identifier_list;
@@ -350,6 +347,6 @@ FCT( Instruction *, function_parameter_t
 	AddLast(Memo, List__List(function_parameter_type_list, 0))
 
-extern FCT(int, ignored_param, () );
-extern FCT(int, typed_param, () );
+extern FCT(int, ignored_param, (void) );
+extern FCT(int, typed_param, (void) );
 
 extern char * ellipsis;
@@ -360,6 +357,6 @@ extern char * ellipsis;
 /**/
 
-extern FCT( int, partial_declaration,() );
-extern FCT( int, declaration,() );
+extern FCT( int, partial_declaration, (void) );
+extern FCT( int, declaration, (void) );
 
 /**/
@@ -376,8 +373,10 @@ extern FCT( Instruction *, array_decl_wi
 	AddLast(Memo, List__List(array_dim, 0))
 
-extern FCT( void, array_abstract_declarator,() );
+extern FCT( void, array_abstract_declarator, (void) );
 
 /**/
 
+FCT( Instruction *, make_block,(List *, int));
+
 FCT( Instruction *, make_function_def,(List *, int)	);
 #define memo_make_function_def()		\
@@ -402,3 +401,3 @@ FCT( Instruction *, make_typedef_oldfunc
 FCT( Instruction *, make_oldfunction_def,(List *, int)	);
 #define memo_make_oldfunction_def()		\
-  	AddLast(Memo, List__List(make_oldfunction_def, 0))
+  	AddLast(Memo, List__List(make_oldfunction_def, 0))
\ No newline at end of file
--- Smac/declaration.c	2006-10-16 16:33:34.000000000 -0400
+++ Smac/declaration.c	2014-12-27 21:45:31.000000000 -0500
@@ -53,4 +53,10 @@
 #include "error.h"
 #include "Declaration_.h"
+#ifdef XCORAL
+#include <X11/X.h>
+#include <X11/Xlib.h>
+#include "../main_text.h"
+#include "../warn_box.h"
+#endif
 
 #include "decl.h" /**/
@@ -61,8 +67,7 @@
   */
 
-static Instruction * global_initialized_array(type, init, varname)
-     Type * type;
+static Instruction * global_initialized_array(init, varname)
      List * init;
-     char * varname;
+     const char * varname;
 {
   if (init->fct != make_initializer_list) {
@@ -82,5 +87,5 @@ Instruction * make_declaration(l, del)
     int del;
 {
-  char * varname = ((char **) l->info)[0];
+  char * varname;
   Type * type = ((Type **) l->info)[1];
   Instruction * initval = 0;
@@ -90,9 +95,10 @@ Instruction * make_declaration(l, del)
     if (((List **) l->info)[2])
       DELETE(((List **) l->info)[2]);
-    free(varname);
+    free(((char **)l->info)[0]);
     free(l->info);
     free(l);
     return 0;
   }
+  varname = ((char **) l->info)[0];
   
   /* manage the optional init value */
@@ -101,5 +107,5 @@ Instruction * make_declaration(l, del)
     if (Type__IsaArray(type) && (! Function_Name))
       initval =
-	global_initialized_array(type, ((List **) l->info)[2], varname);
+	global_initialized_array(((List **) l->info)[2], varname);
     else {
       initval = MAKE(((List **) l->info)[2]);
@@ -165,6 +171,4 @@ Instruction * make_declaration(l, del)
 	else if (Debug_Mode > 1) {
 #ifdef XCORAL
-	  extern FCT(void, DisplayWMessage ,(char *, char *, int));
-	  
 	  DisplayWMessage("Warning : ", "", 1);
 	  DisplayWMessage(varname, "", 0);
@@ -243,5 +247,5 @@ Instruction * make_declaration(l, del)
     HashTable__Add(DynamicVarsHashTable, (Object) varname, (Object) var);
     
-    VarLocList = AddLast(VarLocList, List__List(0, var));
+    AddLast(VarLocList, List__List(0, var));
     
     if (Type__IsaArray(type)) {
@@ -268,5 +272,5 @@ Instruction * make_declaration(l, del)
 
 Instruction * make_initializer_list(ignore, del)
-    List * ignore;
+    List * ignore __attribute__((unused));
     int del;
 {
--- Smac/error.c	2006-10-16 16:31:59.000000000 -0400
+++ Smac/error.c	2014-12-27 17:15:22.000000000 -0500
@@ -46,8 +46,14 @@
 #include "FunctionCall_.h"
 #include "smac.h"
+#ifdef XCORAL
+#include <X11/X.h>
+#include <X11/Xlib.h>
+#include "../main_text.h"
+#include "../warn_box.h"
+#endif
 
 /* Le nom de la fonction en cours de `digestion' */
 
-char * Function_Name = 0;
+const char * Function_Name = NULL;
 
 /* L'adresse de la derniere structure de memorisation
@@ -81,8 +87,4 @@ int Showed_Stack_Size = 10;
 /* Affiche les appels de fonction imbriques */
 
-#ifdef XCORAL
-  extern FCT(void, DisplayWMessage ,(char *, char *, int));
-#endif
-
 void printf_function_called()
 {
@@ -133,5 +135,5 @@ void printf_function_called()
 /* indique dans quel contexte on est */
 
-static char * context()
+static const char * context()
 {
   return (Function_Name)
@@ -164,5 +166,5 @@ static char mess[MSG_SIZE];
 
 void Internal_Error(msg, nojmp)
-    char * msg;
+    const char * msg;
     int nojmp;
 {
@@ -181,5 +183,5 @@ void Internal_Error(msg, nojmp)
 
 void Error(msg, nojmp)
-    char * msg;
+    const char * msg;
     int nojmp;
 {
@@ -198,5 +200,5 @@ void Error(msg, nojmp)
 
 void Fatal_Error(msg)
-     char * msg;
+     const char * msg;
 {
   fprintf(stderr, "Fatal Error in %s : %s\n", context(), msg);
@@ -208,5 +210,5 @@ void Fatal_Error(msg)
 #ifndef XCORAL
 void Warning(msg)
-     char * msg;
+     const char * msg;
 {
   fprintf(stderr, "Warning in %s : %s\n", context(), msg);
@@ -228,5 +230,5 @@ void clear_ctrl_c()
 
 RETSIGTYPE error_ctrl_c(ignore)
-     int ignore;
+     int ignore __attribute__((unused));
 {
   /* May be a warning (prototype is not always the same), not important */
--- Smac/error.h	2002-07-14 17:02:14.000000000 -0400
+++ Smac/error.h	2014-12-27 15:42:58.000000000 -0500
@@ -49,5 +49,5 @@
 #include "word.h"
 
-extern char * Function_Name;
+extern const char * Function_Name;
 extern char err_msg[];
 extern int Debug_Mode;
@@ -65,11 +65,11 @@ extern int Is_Terminal;
 extern int Has_Unterminal_Return;
 
-extern FCT( void, Error_Full_Stack,()		);
-extern FCT( void, Internal_Error,(char *, int)	);
-extern FCT( void, Fatal_Error,(char *)		);
-extern FCT( void, Error,(char *, int)		);
-extern FCT( void, Warning,(char *)		);
+extern FCT( void, Error_Full_Stack, (void)		);
+extern FCT( void, Internal_Error, (const char *, int)	);
+extern FCT( void, Fatal_Error, (const char *)		);
+extern FCT( void, Error, (const char *, int)		);
+extern FCT( void, Warning, (const char *)		);
 
-extern FCT( void, printf_function_called,()	);
+extern FCT( void, printf_function_called, (void)	);
 
 extern int Showed_Stack_Size;
@@ -89,10 +89,10 @@ typedef enum { NO_JMP,
 
 extern int During_Evaluation;
-extern FCT( void, accept_ctrl_c,()	);
+extern FCT( void, accept_ctrl_c, (void)		);
 extern FCT( RETSIGTYPE, error_ctrl_c,(int)	);
-extern FCT( void, clear_ctrl_c,()	);
+extern FCT( void, clear_ctrl_c, (void)		);
 
 #define ignore_ctrl_c() 		During_Evaluation = 0
 
 
-#endif
+#endif
\ No newline at end of file
--- Smac/function.c	2006-10-16 16:33:28.000000000 -0400
+++ Smac/function.c	2014-12-27 21:44:24.000000000 -0500
@@ -57,4 +57,10 @@
 #include "decl.h" /**/
 
+#ifdef XCORAL
+#include <X11/X.h>
+#include <X11/Xlib.h>
+#include "../main_text.h"
+#include "../warn_box.h"
+#endif
 
 /* Le type retourne par la fonction en cours de definition */
@@ -167,5 +173,5 @@ int function_declaration(identifier, par
   *************************/
 
-void function_definition(valtype, funcname, params, body)
+static void function_definition(valtype, funcname, params, body)
      Type * valtype;
      char * funcname;
@@ -184,5 +190,5 @@ void function_definition(valtype, funcna
 
   /* L'Identifier */
-  
+ 
   identifier = Get_Identifier(funcname);
   funcname = 
@@ -212,6 +218,4 @@ void function_definition(valtype, funcna
       if (Debug_Mode > 1) {
 #ifdef XCORAL
-	extern FCT(void, DisplayWMessage ,(char *, char *, int));
-	
 	DisplayWMessage("Warning : ", "", 1);
 	DisplayWMessage(funcname, "", 0);
@@ -281,6 +285,6 @@ void function_definition(valtype, funcna
       }
 
-      Return_Value_Type = 0;
-      Function_Name = 0;
+      Return_Value_Type = NULL;
+      Function_Name = NULL;
       Is_Terminal = 0;
       
@@ -292,6 +296,6 @@ void function_definition(valtype, funcna
   }
 
-  Return_Value_Type = 0;
-  Function_Name = 0;
+  Return_Value_Type = NULL;
+  Function_Name = NULL;
   Is_Terminal = 0;
   VarLocList = 0;
--- Smac/function.h	2006-10-16 16:30:32.000000000 -0400
+++ Smac/function.h	2014-12-27 15:38:40.000000000 -0500
@@ -55,5 +55,5 @@ extern int DynamicVar_FramePosition;
 extern List * VarLocList;
 
-extern void Init_function();
+extern void Init_function(void);
 
 #endif
